import {
  GetDestinationCityPage,
  GetDestinationCityPageRefs,
} from "@/lib/graphql/Query/DestinationCityPage/DestinationCityPage.graphql"
import { request } from "@/lib/graphql/request"
import { notFound } from "@/server/errors/trpc"
import { createCounter } from "@/server/telemetry"
import { contentStackUidWithServiceProcedure, router } from "@/server/trpc"

import { generateRefsResponseTag } from "@/utils/generateTag"

import { getCityByCityIdentifier } from "../../hotels/utils"
import {
  destinationCityPageRefsSchema,
  destinationCityPageSchema,
} from "./output"
import { generatePageTags } from "./utils"

import {
  TrackingChannelEnum,
  type TrackingSDKPageData,
} from "@/types/components/tracking"
import type {
  GetDestinationCityPageData,
  GetDestinationCityPageRefsSchema,
} from "@/types/trpc/routers/contentstack/destinationCityPage"

export const destinationCityPageQueryRouter = router({
  get: contentStackUidWithServiceProcedure.query(async ({ ctx }) => {
    const { lang, uid, serviceToken } = ctx

    const getDestinationCityPageRefsCounter = createCounter(
      "trpc.contentstack",
      "destinationCityPage.get.refs"
    )
    const metricsGetDestinationCityPageRefs =
      getDestinationCityPageRefsCounter.init({ lang, uid })

    metricsGetDestinationCityPageRefs.start()

    const refsResponse = await request<GetDestinationCityPageRefsSchema>(
      GetDestinationCityPageRefs,
      { locale: lang, uid },
      {
        key: generateRefsResponseTag(lang, uid),
        ttl: "max",
      }
    )

    if (!refsResponse.data) {
      const notFoundError = notFound(refsResponse)
      metricsGetDestinationCityPageRefs.noDataError()
      throw notFoundError
    }

    const validatedRefsData = destinationCityPageRefsSchema.safeParse(
      refsResponse.data
    )
    if (!validatedRefsData.success) {
      metricsGetDestinationCityPageRefs.validationError(validatedRefsData.error)
      return null
    }

    metricsGetDestinationCityPageRefs.success()

    const tags = generatePageTags(validatedRefsData.data, lang)

    const getDestinationCityPageCounter = createCounter(
      "trpc.contentstack",
      "destinationCityPage.get"
    )
    const metricsGetDestinationCityPage = getDestinationCityPageCounter.init({
      lang,
      uid,
    })

    metricsGetDestinationCityPage.start()

    const response = await request<GetDestinationCityPageData>(
      GetDestinationCityPage,
      {
        locale: lang,
        uid,
      },
      {
        key: tags,
        ttl: "max",
      }
    )
    if (!response.data) {
      const notFoundError = notFound(response)
      metricsGetDestinationCityPage.noDataError()
      throw notFoundError
    }

    const validatedResponse = destinationCityPageSchema.safeParse(response.data)

    if (!validatedResponse.success) {
      metricsGetDestinationCityPage.validationError(validatedResponse.error)
      return null
    }

    const destinationCityPage = validatedResponse.data.destination_city_page
    const cityIdentifier = destinationCityPage.destination_settings.city
    if (!cityIdentifier) {
      return null
    }

    const city = await getCityByCityIdentifier({
      cityIdentifier,
      lang,
      serviceToken,
    })

    if (!city) {
      metricsGetDestinationCityPage.dataError(
        `Failed to get city data for ${cityIdentifier}`,
        {
          cityIdentifier,
        }
      )
      return null
    }

    metricsGetDestinationCityPage.success()

    const system = destinationCityPage.system
    const pageName = `destinations|${city.country}|${city.name}`

    const tracking: TrackingSDKPageData = {
      pageId: system.uid,
      domainLanguage: system.locale,
      publishDate: system.updated_at,
      createDate: system.created_at,
      channel: TrackingChannelEnum.hotels,
      pageType: "citypage",
      pageName,
      siteSections: pageName,
      siteVersion: "new-web",
    }

    return {
      destinationCityPage,
      cityIdentifier,
      city,
      tracking,
    }
  }),
})
